/**
 * Trida Queue representuje frontu
 * 
 * @author Jiri Kremser 
 * @version 1.0    16. 10. 2006
 */
public class Queue<Item>{
    private int N;         // number of elements on queue
    private Node first;    // beginning of queue
    private Node last;     // end of queue

    // helper linked list class
    private class Node {
        private Item item;
        private Node next;

        Node(Item item, Node next) {
            this.item = item;
            this.next = next;
        }
    }
    public Item look(){
      if (isEmpty()) throw new RuntimeException("Queue underflow");
      return first.item;
    }
    
    // is the queue empty?
    public boolean isEmpty() { return first == null; }
    public int size()        { return N;             }

    // add an item to the queue
    public void enqueue(Item item) {
        Node x = new Node(item, null);
        if (isEmpty()) { first = x;     last = x; }
        else           { last.next = x; last = x; }
        N++;
    }

    // remove and return the least recently added item
    public Item dequeue() {
        if (isEmpty()) throw new RuntimeException("Queue underflow");
        Item item = first.item;
        first = first.next;
        N--;
        return item;
    }
  }